﻿using System.ComponentModel;
using System.Collections.ObjectModel;
using System.Windows.Input;
using Telerik.Windows.Controls;

namespace DeleteCommandInMVVM
{
	public class MyViewModel : INotifyPropertyChanged
	{
		public event PropertyChangedEventHandler PropertyChanged;

		private ObservableCollection<Club> clubs;
		private ObservableCollection<Player> players;
		private object selectedItem;

		public ICommand DeleteCrewCommand{get;set;}
		public ICommand DeleteCrewMemberCommand = RadGridViewCommands.Delete;
 

		public MyViewModel()
		{
			DeleteCrewCommand = new DelegateCommand<object>(DeleteCrewMemberCommand_Execute);
		}


		public ObservableCollection<Club> Clubs
		{
			get
			{
				if (this.clubs == null)
				{
					this.clubs = Club.GetClubs();
				}

				return this.clubs;
			}
		}

		public ObservableCollection<Player> Players
		{
			get
			{
				if (this.players == null)
				{
					this.players = Player.GetPlayers();
				}

				return this.players;
			}
		}

		public object SelectedItem
		{
			get
			{
				return this.selectedItem;
			}
			set
			{
				if (value != this.selectedItem)
				{
					this.selectedItem = value;
					this.OnPropertyChanged("SelectedItem");
				}
			}
		}

		protected virtual void OnPropertyChanged(PropertyChangedEventArgs args)
		{
			PropertyChangedEventHandler handler = this.PropertyChanged;
			if (handler != null)
			{
				handler(this, args);
			}
		}

		private void OnPropertyChanged(string propertyName)
		{
			this.OnPropertyChanged(new PropertyChangedEventArgs(propertyName));
		}

		private void DeleteCrewMemberCommand_Execute(object obj)
		{
			//DeleteCrewMemberCommand.Execute(true);
			//TODO: How to find the selecteditem?
			Players.Remove((Player)obj);
		}
	}
}
